.SUFFIXES: .asm

# defines
MAKEFILE=Makefile
MAKEDEP=$(MAKEFILE)
NASM	=nasm -f elf
GLIBC   =../../libc
LSCRIPT	=./link.ld
LFLAGS	=-g -T$(LSCRIPT)
INCDIR	=$(GLIBC)/include
CC	=gcc -m32 -g -O2 -Wall -W -c -nostdinc -fno-builtin -fno-stack-protector -I$(INCDIR)
#-Wall -W
LD	=ld -m elf_i386 -s -nostdlib
LIBC    =$(GLIBC)/libc.a
OBJS	=start.o main.o net.o http.o

# targets
all: webcl

linux:
	gcc -owebcl_linux main.c net.c http.c -DLINUX

install: webcl
	mkdir mnt
	mount /dev/fd0 mnt
	cp -f webcl ./mnt/webcl
	umount mnt
	rmdir mnt

iso: webcl
	cp webcl ../../iso/

clean:
	rm -f *.o webcl webcl.img $(OBJS)
# implicit rules
.asm.o:
	$(NASM) -o$@ $<

.c.o:
	$(CC) -c -o$@ $<

#: dependencies
# boot
start.o:				start.asm			$(MAKEDEP)
# core
main.o:					main.c				$(MAKEDEP)
http.o:					http.c				$(MAKEDEP)

# explicit rules
webcl: $(OBJS) $(LIBC) $(MAKEDEP)
	$(LD) $(LFLAGS) -o$@ $(OBJS) $(LIBC)